SystemOrganization addCategory: #'GT-Debugger'!

!DebugAction methodsFor: '*GT-Debugger' stamp: 'AndreiChis 6/27/2013 11:43'!
asGlamourAction

	^ ((GLMGenericAction new) 
			action: [ self execute ]; 
			icon: self icon;
			title: self label;
			category: self category;
			yourself)! !

DebugAction subclass: #GTTemporaryPreDebugChangeDebuggerAction
	instanceVariableNames: 'preDebugWindow'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTTemporaryPreDebugChangeDebuggerAction class methodsFor: 'registration' stamp: 'AndreiChis 11/13/2013 23:09'!
actionType
	<preDebuggingAction>! !

!GTTemporaryPreDebugChangeDebuggerAction methodsFor: 'accessing' stamp: 'AndreiChis 11/13/2013 22:55'!
defaultLabel

	^ 'Debug Glamorously'! !

!GTTemporaryPreDebugChangeDebuggerAction methodsFor: 'accessing' stamp: 'AndreiChis 11/13/2013 22:55'!
defaultOrder

	^ 200! !

!GTTemporaryPreDebugChangeDebuggerAction methodsFor: 'actions' stamp: 'AndreiChis 11/13/2013 23:07'!
executeAction
	| currentDebugger currentSession |
	
	"Close the spec PreDebugWindow and debugger"
	currentDebugger := self preDebugWindow debugger.
	self preDebugWindow debugger: nil.
	self preDebugWindow close.
	currentSession := currentDebugger session.
	currentDebugger session: nil.
	currentDebugger close.
	
	GTDebugger debugSession: currentDebugger session! !

!GTTemporaryPreDebugChangeDebuggerAction methodsFor: 'accessing' stamp: 'AndreiChis 11/13/2013 22:55'!
id

	^ #gtChangeDebuggerPreDebug! !

!GTTemporaryPreDebugChangeDebuggerAction methodsFor: 'accessing' stamp: 'AndreiChis 11/13/2013 22:59'!
preDebugWindow
	
	^ preDebugWindow! !

!GTTemporaryPreDebugChangeDebuggerAction methodsFor: 'accessing' stamp: 'AndreiChis 11/13/2013 22:59'!
preDebugWindow: anObject
	
	preDebugWindow := anObject! !

!ChangeDebuggerAction class methodsFor: '*GT-Debugger' stamp: 'AndreiChis 7/14/2013 23:49'!
gtChangeDebuggerActionsFor: aDebugger
	<gtDebuggingAction>
	
	^ self 
		changeDebuggerActionsForContext: aDebugger interruptedContext 
		excluding: aDebugger! !

!SaveDebugAction methodsFor: '*GT-Debugger' stamp: 'AndreiChis 6/18/2013 17:23'!
asGlamourAction

	^ super asGlamourAction
			action: [ :textPresentation | 
				self sourceCode: textPresentation text.
				self execute ]! !

!InstructionStream methodsFor: '*GT-Debugger' stamp: 'AndreiChis 6/29/2013 20:29'!
isInitialnstruction

	^ self pc = self method initialPC! !

!DebugContext methodsFor: '*gt-debugger' stamp: 'AndreiChis 6/5/2013 14:53'!
gtDebuggerRetrieveVariableValuePairs
	|fieldList|

	fieldList := OrderedCollection new.
	fieldList 
		add: ('_self' ->  context receiver);
	      addAll: (context receiver class allInstVarNames collect: [:each | each -> (context receiver instVarNamed: each) ]).
	
	fieldList add: ('_thisContext' ->  context).
	 context == nil ifTrue: [^fieldList].
	fieldList 
		add: ('_stack top' -> ( context stackPtr > 0 ifTrue: [ context top])).
		
	(context tempNames size > 0) ifTrue: [
		fieldList addAll: ((1 to: context tempNames size) collect: [ :index || key value |
			key := context tempNames at: index.
			value := [context debuggerMap namedTempAt: index in: context] 
				on: Error 
				do: [value := (Text string: 'error obtaining field value' attribute: TextColor red) asString ].
			key -> value ] ) ].
	
	^ fieldList! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/26/2013 11:40'!
createPredicateForBlock: aBlock 

	^ BlockContextPredicate for: aBlock! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/14/2013 18:17'!
createStepPredicateForBlock: aBlock 

	^ self createStepPredicatForPredicate: (self createPredicatForBlock: aBlock)
			! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/20/2013 16:46'!
createStepPredicateForPredicate: aPredicate
	" Subclasses should specialize this method if needed. "
	^ aPredicate! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/20/2013 17:22'!
createStepPredicateForPredicate: aPredicate fromContext: targetContext

	^ (self createPredicateForBlock: [ :currentContext |
		(self isActive: targetContext) not or: [ currentContext isHaltContext ] ]) 
			or: aPredicate
	! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/14/2013 18:21'!
isActive: aContext

	^ true! !

!DebugSession methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/26/2013 11:51'!
stepUntil: aPredicate from: aContext 
	| ctxt |
	
	ctxt := self process stepUntil: (self createStepPredicateForPredicate: aPredicate) from: aContext.
	self  
		updateWithContext: ctxt 
		fromProcess: self process.! !

!Process methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/26/2013 11:51'!
stepUntil: aPredicate from: aContext
	"Resume self until the top context safisfy the given condition."

	| ctxt  |
	
	ctxt := aContext.
	[ 
		ctxt notNil and: [aPredicate matches: ctxt]
	] whileFalse: [
		ctxt := self step: ctxt.
	].
	^ ctxt! !

GLMCompositePresentation subclass: #GTDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTDebugger commentStamp: '<historical>' prior: 0!
GTDebugger is a browser that provides Smalltalk debugging functionality.
 
An example: 
[ GTDebugger debugProcess: Processor activeProcess.
	Processor activeProcess suspend.
	#(1 2 3 4 5) do: [:each | each asString]
] fork.!

!GTDebugger class methodsFor: 'instance creation' stamp: 'AndreiChis 4/2/2013 14:49'!
debugBasedOnSession: aSession

	^ self debugSession: ((self spanNewSessionForContext: aSession context fromProcess: aSession process)
		errorWasInUIProcess: aSession errorWasInUIProcess)! !

!GTDebugger class methodsFor: 'instance creation' stamp: 'AndreiChis 1/28/2013 16:39'!
debugContext: aContext fromProcess: aProcess

	^ self debugSession: (self spanNewSessionForContext: aContext fromProcess: aProcess)! !

!GTDebugger class methodsFor: 'instance creation' stamp: 'AndreiChis 1/28/2013 16:39'!
debugProcess: aProcess

	^ self debugContext: aProcess suspendedContext fromProcess: aProcess! !

!GTDebugger class methodsFor: 'instance creation' stamp: 'AndreiChis 1/28/2013 16:39'!
debugSession: aSession

	<primitive: 19> "simulation guard"

	"WorldState addDeferredUIMessage: ["
		^ self openOn: aSession 
	"]"! !

!GTDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 3/26/2013 15:33'!
defaultTitle
	^ 'Glamorous Debugger'! !

!GTDebugger class methodsFor: 'testing' stamp: 'AndreiChis 3/25/2013 14:42'!
handlesContext: aContext

	^ true! !

!GTDebugger class methodsFor: 'instance creation' stamp: 'TudorGirba 11/25/2012 23:00'!
openOn: anObject 
	^ self new openOn: anObject! !

!GTDebugger class methodsFor: 'tools registry' stamp: 'AndreiChis 7/15/2013 16:38'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	registry registerDebugger: self withRank: 3.! !

!GTDebugger class methodsFor: 'private' stamp: 'AndreiChis 1/13/2013 20:19'!
sessionClass

	^ DebugSession ! !

!GTDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 1/15/2013 12:07'!
spanNewSessionForContext: aContext fromProcess: aProcess

	^ self sessionClass process: aProcess context: aContext ! !

!GTDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 1/28/2013 14:33'!
spanNewSessionForProcess: aProcess

	^ self spanNewSessionForContext: aProcess suspendedContext fromProcess: aProcess! !

!GTDebugger methodsFor: 'callbacks' stamp: 'AndreiChis 3/27/2013 11:56'!
actOnBrowserClosing: ann
	self session ifNotNil: [ :aSession | aSession terminate ]! !

!GTDebugger methodsFor: 'building actions' stamp: 'AndreiChis 7/4/2013 15:08'!
actionsForPragmas: aSymbolsCollection

	^ ((self allActionsForPragmas: aSymbolsCollection) select: [ :aDebugAction | 
			aDebugAction appliesToContextCurrentContext ]) 
				collect: [ :aDebugAction | aDebugAction asGlamourAction ]
! !

!GTDebugger methodsFor: 'building actions' stamp: 'AndreiChis 11/13/2013 23:12'!
allActionsForPragmas: aSymbolsCollection
	
	^ (self session class 
		debuggingActionsForPragmas: aSymbolsCollection for: self debugger)

	
! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 6/20/2013 14:37'!
browser 

	^ self presentations first! !

!GTDebugger methodsFor: 'actions' stamp: 'AndreiChis 6/17/2013 16:31'!
close

	self browser close! !

!GTDebugger methodsFor: 'building actions' stamp: 'AndreiChis 6/27/2013 12:13'!
codeActionsPragmas

	^ { #codeDebuggingAction }! !

!GTDebugger methodsFor: 'building' stamp: 'AndreiChis 6/20/2013 12:03'!
compose
	self title: self debuggerTitle.
	self tabulator with: [:browser | 
		self debuggerStructureIn: browser.
		self debuggerTransmissionsIn: browser ].
	self registerActions.
! !

!GTDebugger methodsFor: 'accessing context' stamp: 'AndreiChis 6/20/2013 14:41'!
currentContext

	^self selectedContext 
		ifNil: [ self interruptedContext ] 
		ifNotNil:  [ self selectedContext  ]! !

!GTDebugger methodsFor: 'actions' stamp: 'AndreiChis 4/1/2013 16:19'!
debug: aContext using: aDebuggerClass
	| currentSession  |
	
	currentSession := self session.
	self detachSession.
	self browser close.
	currentSession updateContextTo: aContext.
	aDebuggerClass debugBasedOnSession: currentSession! !

!GTDebugger methodsFor: 'building' stamp: 'AndreiChis 6/20/2013 12:01'!
debuggerStructureIn: browser
	
	browser
		row: [ :row | 
					row
						column: #stack;
						column: #code ];
		row: #inspector.
		! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 3/26/2013 15:35'!
debuggerTitle
	
	^ self class defaultTitle ! !

!GTDebugger methodsFor: 'building' stamp: 'AndreiChis 9/9/2013 13:42'!
debuggerTransmissionsIn: browser

	browser transmit
		fromOutsideEntityPort;
		to: #stack;
		andShow: [ :composite | self stackIn: composite ].
	browser transmit
		from: #stack port: #entity;
		to: #stack port: #selection;
		when: [ :session | session notNil ];
		transformed: [:session | session context].
	browser transmit
		from: #stack port: #selection;
		to: #code;
		andShow: [ :composite :aContext | self methodCodeIn: composite forContext: aContext ].
	browser transmit
		from: #stack port: #selection;
		to: #inspector;
		andShow: [ :composite | self inspectorIn: composite ] 
! !

!GTDebugger methodsFor: 'building actions' stamp: 'AndreiChis 6/27/2013 12:13'!
debuggingActionsPragmas

	^ { #debuggingAction }! !

!GTDebugger methodsFor: 'actions' stamp: 'AndreiChis 7/4/2013 16:54'!
detachSession
	self flag: 'why silent value?'.
	(self browser pane port: #entity) silentValue: nil! !

!GTDebugger methodsFor: 'intialization' stamp: 'AndreiChis 3/27/2013 11:59'!
errorWasInUIProcess: aBoolean

	self session errorWasInUIProcess: aBoolean! !

!GTDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 7/8/2013 14:10'!
inspectorIn: composite

	composite custom:
			(GTInspector new first "We use the first actual finder because need to send showFirst: to it"
				noTitle;
				noActions;
				showFirst: [ :a | a custom: (GTDebuggerVariablesBrowser new) ];
				yourself)
	! !

!GTDebugger methodsFor: 'building actions' stamp: 'AndreiChis 6/27/2013 12:22'!
installActionsForRootPragmas: aSymbolsCollection in: aPresentation

	aPresentation dynamicActions: [ :presentation |
		self actionsForPragmas: (aSymbolsCollection collect: [ :aSymbol | #gt, aSymbol capitalized ]) ] .
	
	aPresentation dynamicActionsOnSelection: [ :presentation |
		self actionsForPragmas: (aSymbolsCollection collect: [ :aSymbol | #gtContext, aSymbol capitalized ]) ] .! !

!GTDebugger methodsFor: 'building actions' stamp: 'AndreiChis 6/27/2013 12:16'!
installCodeActionsFor: aPresentation
	
	self installActionsForRootPragmas: self codeActionsPragmas in: aPresentation! !

!GTDebugger methodsFor: 'building actions' stamp: 'AndreiChis 6/27/2013 12:14'!
installDebuggingActionsFor: aPresentation

	self installActionsForRootPragmas: self debuggingActionsPragmas in: aPresentation! !

!GTDebugger methodsFor: 'accessing context' stamp: 'AndreiChis 6/19/2013 19:07'!
interruptedContext

	^ self session context! !

!GTDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 9/9/2013 13:42'!
methodCodeIn: composite forContext: aContext

	(self methodCodeWidgetIn: composite)
		initialize: [ :code | code selectionInterval: (self session selectedCodeRangeForContext: self currentContext) ];
		with: [ :code | self installCodeActionsFor: code ]! !

!GTDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 9/9/2013 13:18'!
methodCodeWidgetIn: composite

	^ composite smalltalkCode
		title: 'Source';
		format: #sourceCode;
		smalltalkClass: [ :context | context methodClass ];
		doItReceiver: [ :context | context receiver ];
		doItContext: [ :context | context ]! !

!GTDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 9/9/2013 09:36'!
methodCodeWidgetIn: composite forContext: aContext

	^ composite smalltalkCode
		title: 'Source';
		format: [ aContext sourceCode ];
		smalltalkClass: [  aContext methodClass ];
		doItReceiver: [ aContext receiver ];
		doItContext: [  aContext ]! !

!GTDebugger methodsFor: 'opening' stamp: 'AndreiChis 11/13/2013 22:36'!
openFullNoSuspendLabel: aString
	"TODO: do not ignore the title"
	
	self open.
	self flag: 'why is this necessy here? I took it from the current debugger' 
	"errorWasInUIProcess := UIManager default spawnNewProcessIfThisIsUI: interruptedProcess"! !

!GTDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 8/7/2013 14:21'!
printStackEntry: aContext

	^ String streamContents: [:stream | aContext printDebugOn: stream ] ! !

!GTDebugger methodsFor: 'intialization' stamp: 'AndreiChis 3/27/2013 12:00'!
process: aProcess controller: aController context: aContext

	self session: (self class spanNewSessionForContext: aContext fromProcess: aProcess)! !

!GTDebugger methodsFor: 'building' stamp: 'AndreiChis 7/4/2013 15:36'!
registerActions

	self on: GLMBrowserClosing send: #actOnBrowserClosing: to: self.
	self on: DebugActionExecuted send: #updateBrowser to: self.
! !

!GTDebugger methodsFor: 'accessing context' stamp: 'AndreiChis 6/20/2013 14:37'!
selectedContext

	^ ((self browser paneNamed: #stack) port: #selection) value! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 7/12/2013 18:13'!
selectionInterval

	^ self selectionIntervalForPane: #code! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 7/4/2013 15:37'!
selectionInterval: anInterval

	^ ((self browser paneNamed: #code) port: #selectionInterval) value: anInterval! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 7/12/2013 18:12'!
selectionIntervalForPane: aSymbol

	^ ((self browser paneNamed: aSymbol) port: #selectionInterval) value ifNil: [ ^ 1 to: 0 ]! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 7/4/2013 17:07'!
session
 
	^ (self browser pane port: #entity) value! !

!GTDebugger methodsFor: 'accessing' stamp: 'AndreiChis 3/27/2013 11:58'!
session: anObject

	^ (self browser pane port: #entity) value: anObject! !

!GTDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 8/30/2013 14:46'!
stackIn: composite

	(self stackWidgetIn: composite)
		with: [ :stackWidget | self installDebuggingActionsFor: stackWidget ]! !

!GTDebugger methodsFor: 'building presentations' stamp: 'AndreiChis 8/30/2013 14:45'!
stackWidgetIn: composite

	^ composite list	
		title: 'Stack';
		showOnly: 50;
		display: #stack;
		format: [ :each | self printStackEntry: each]! !

!GTDebugger methodsFor: 'updating' stamp: 'AndreiChis 9/9/2013 09:25'!
updateBrowser
	| browserPane session |
	
	session := self session.
	browserPane := self browser pane.
	(browserPane port: #entity) silentValue: nil.
	(browserPane port: #entity) value: session.
	browserPane update.! !

!GTDebugger methodsFor: 'updating' stamp: 'AndreiChis 3/27/2013 12:00'!
updateSelectionInterval

	self selectionInterval: (self session pcRangeForContext:  self selectedContext )! !

!GTDebugger methodsFor: 'callbacks' stamp: 'AndreiChis 1/15/2013 15:08'!
windowIsClosing 
	self announce: GLMBrowserClosing new! !

GLMCompositePresentation subclass: #GTDebuggerVariablesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Debugger'!

!GTDebuggerVariablesBrowser commentStamp: 'TudorGirba 11/2/2012 22:06' prior: 0!
GTDebuggerVariablesBrowser is a special browser that is used in the first pane of the inspector that is embedded in the debugger. Its main intention is to provide a unified list of variables that come from:
- the instance variables of the receiver
- the local variables from the context!

!GTDebuggerVariablesBrowser methodsFor: 'building' stamp: 'TudorGirba 11/25/2012 22:57'!
compose  
	self title: [:each | GTInspector new printObjectAsAnItem: each receiver ].
	self tabulator with: [:browser | 
		browser 
			morphicAct: [:anotherComposite | anotherComposite entity receiver browse]
				icon: GLMUIThemeExtraIcons glamorousBrowse 
				entitled: 'Browse'.
		browser row: #variables; row: #evaluator.
		browser transmit to: #variables; andShow: [:a | 
			self variablesIn: a ].
		browser transmit to: #evaluator; andShow: [:a | 
			self evaluatorIn: a ].
		browser transmit from: #variables; toOutsidePort: #selection.
		browser transmit from: #evaluator; toOutsidePort: #selection ]! !

!GTDebuggerVariablesBrowser methodsFor: 'private building' stamp: 'AndreiChis 10/30/2012 21:03'!
evaluatorIn: composite
	(composite smalltalkCode)
		doItReceiver: #yourself;
		display: [ :model | [model receiver printString asSmalltalkComment, String cr, 'self'] on: Error do: ['"Error printing. Try self printString to debug"'] ];
		selectionPopulate: #selection
			on: $o
			entitled: 'Do it and open (o)'
			with: [ :text :model | Compiler evaluate: text selectedText for: model receiver logged: false ]! !

!GTDebuggerVariablesBrowser methodsFor: 'private building' stamp: 'AndreiChis 8/26/2013 16:15'!
variablesIn: composite
	composite table
		showOnly: 50;
		display: [ :context | context gtDebuggerRetrieveVariableValuePairs ];
		sorted: [:variablePair1 :variablePair2 | variablePair1 key < variablePair2 key];
		column: 'Variable' evaluated: [:assoc | 
			[ Text fromString: assoc key asString ]
						on: Error
						do: [ Text string: 'error printing' attribute: TextColor red ] ];
		column: 'Value' evaluated: [:assoc | 
			[ Text fromString: (assoc value printString contractTo: 50) ]
						on: Error
						do: [ Text string: 'error printing' attribute: TextColor red ] ];
"		icon: [ :each |
			each value class theNonMetaClass browserIcon
				ifNotNil: [ OBMorphicIcons iconNamed: each value class theNonMetaClass browserIcon ] ];"
		send: #value;
		morphicSelectionAct: [:each | each value browse ] 
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			on: $b 
			entitled: 'Browse'! !

!MethodContext methodsFor: '*GT-Debugger' stamp: 'AndreiChis 8/26/2013 16:14'!
gtDebuggerRetrieveVariableValuePairs
	|fieldList context|

	fieldList := OrderedCollection new.
	context := self.
	fieldList 
		add: ('_self' ->  context receiver);
	      addAll: (context receiver class allInstVarNames collect: [:each | each -> (context receiver instVarNamed: each) ]).
	
	fieldList add: ('_thisContext' ->  context).
	 context == nil ifTrue: [^fieldList].
	fieldList 
		add: ('_stack top' -> ( context stackPtr > 0 ifTrue: [ context top])).
		
	(context tempNames size > 0) ifTrue: [
		fieldList addAll: ((1 to: context tempNames size) collect: [ :index || key value |
			key := context tempNames at: index.
			value := [context debuggerMap namedTempAt: index in: context] 
				on: Error 
				do: [value := (Text string: 'error obtaining field value' attribute: TextColor red) asString ].
			key -> value ] ) ].
	
	^ fieldList! !

!ContextPart methodsFor: '*gt-debugger' stamp: 'AndreiChis 8/20/2013 17:20'!
isHaltContext

	^ self method selector = #halt! !
